<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

class ps_payline {
	
	var $classname = "ps_payline";
	var $payment_code = "PAYLINE";

	// List of supported currencies by the PAYLINE system.
	var $currencies = array(
			'EUR' => '978',
			'USD' => '840',
			'CHF' => '756',
			'GBP' => '826',
			'CAD' => '124',
	);

	/**
	 * Show all configuration parameters for this payment method
	 * @returns boolean False when the Payment method has no configration
	 */
	function show_configuration() {
		global $VM_LANG;
		$db = new ps_DB();

		// Read current Configuration
		include_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
		$lang = jfactory::getLanguage();
		$name= $lang->getBackwardLang();
		if( file_exists(CLASSPATH ."payment/payline/languages/lang.".$name.".admin.php")) {
			include_once(CLASSPATH ."payment/payline/languages/lang.".$name.".admin.php");
		} else {
			include_once(CLASSPATH ."payment/payline/languages/lang.french.admin.php");
		}
		?>
<table class="adminform">
	<tr class="row1">
		<td><strong><?php echo PAYLINE_TEXT_MERCHANT_ID?></strong></td>
		<td><input type="text" name="PAYLINE_MERCHANT_ID" class="inputbox"
			size="50" value="<?php  echo MERCHANT_ID ?>" /></td>
		<td><?php echo PAYLINE_TEXT_MERCHANT_ID_EXPLAIN?></td>
	</tr>
	<tr class="row0">
		<td><strong><?php echo PAYLINE_TEXT_ACCESS_KEY?></strong></td>
		<td><input type="text" name="PAYLINE_ACCESS_KEY" class="inputbox"
			size="50" value="<?php  echo ACCESS_KEY ?>" /></td>
		<td><?php echo PAYLINE_TEXT_ACCESS_KEY_EXPLAIN?></td>
	</tr>
	<tr class="row1">
		<td><strong><?php echo PAYLINE_TEXT_ENVIRONMENT ?></strong></td>
		<td><select name="PAYLINE_ENVIRONMENT" class="inputbox">
			<option <?php if (!PRODUCTION) echo "selected=\"selected\""; ?>
				value="HOMO"><?php echo PAYLINE_TEXT_ENVIRONMENT_HOMO ?></option>
			<option <?php if (PRODUCTION) echo "selected=\"selected\""; ?>
				value="PROD"><?php echo PAYLINE_TEXT_ENVIRONMENT_PROD ?></option>
		</select></td>
		<td><?php echo PAYLINE_TEXT_ENVIRONMENT_EXPLAIN ?></td>
	</tr>
	<tr class="row0">
		<td><strong><?php echo PAYLINE_TEXT_PROXY_HOST?></strong></td>
		<td><input type="text" name="PAYLINE_PROXY_HOST" class="inputbox"
			size="50" value="<?php echo PROXY_HOST ?>" /></td>
		<td></td>
	</tr>
	<tr class="row1">
		<td><strong><?php echo PAYLINE_TEXT_PROXY_PORT?></strong></td>
		<td><input type="text" name="PAYLINE_PROXY_PORT" class="inputbox"
			size="50" value="<?php echo PROXY_PORT ?>" /></td>
		<td></td>
	</tr>
	<tr class="row0">
		<td><strong><?php echo PAYLINE_TEXT_PROXY_LOGIN?></strong></td>
		<td><input type="text" name="PAYLINE_PROXY_LOGIN" class="inputbox"
			size="50" value="<?php echo PROXY_LOGIN ?>" /></td>
		<td></td>
	</tr>
	<tr class="row1">
		<td><strong><?php echo PAYLINE_TEXT_PROXY_PASSWORD?></strong></td>
		<td><input type="text" name="PAYLINE_PROXY_PASSWORD" class="inputbox"
			size="50" value="<?php echo PROXY_PASSWORD ?>" /></td>
		<td></td>
	</tr>
	<tr class="row0">
		<td><strong><?php echo PAYLINE_TEXT_PAYMENT_TYPE ?></strong></td>
		<td><select name="PAYLINE_PAYMENT_TYPE" class="inputbox">
			<option
			<?php if (PAYMENT_ACTION == '100') echo "selected=\"selected\""; ?>
				value="100"><?php echo PAYLINE_TEXT_PAYMENT_TYPE_AUTH ?></option>
			<option
			<?php if (PAYMENT_ACTION == '101') echo "selected=\"selected\""; ?>
				value="101"><?php echo PAYLINE_TEXT_PAYMENT_TYPE_AUTH_CAPT ?></option>
		</select></td>
		<td></td>
	</tr>
	<tr class="row1">
		<td><strong><?php echo PAYLINE_TEXT_CONTRACT?></strong></td>
		<td><input type="text" name="PAYLINE_CONTRACT" class="inputbox"
			size="50" value="<?php echo CONTRACT_NUMBER ?>" /></td>
		<td></td>
	</tr>
	<tr class="row0">
		<td><strong><?php echo PAYLINE_TEXT_CONTRACT_LIST?></strong></td>
		<td><input type="text" name="PAYLINE_CONTRACT_LIST" class="inputbox"
			size="50" value="<?php echo CONTRACT_NUMBER_LIST ?>" /></td>
		<td></td>
	</tr>
	<tr class="row1">
		<td><strong><?php echo PAYLINE_TEXT_SECURITY_MODE?></strong></td>
		<td><select name="PAYLINE_SECURITY_MODE" class="inputbox">
			<option
			<?php if (SECURITY_MODE == 'SSL') echo "selected=\"selected\""; ?>
				value="SSL">SSL</option>
			<option
			<?php if (SECURITY_MODE != 'SSL') echo "selected=\"selected\""; ?>
				value="">- none -</option>
		</select></td>
		<td><?php echo PAYLINE_TEXT_SECURITY_MODE_EXPLAIN ?></td>
	</tr>
	<tr class="row0">
		<td><strong><?php echo PAYLINE_TEXT_LANGUAGE_CODE?></strong></td>
		<td><select name="PAYLINE_LANGUAGE_CODE" class="inputbox">
			<option
			<?php if (@LANGUAGE_CODE == 'fr') echo "selected=\"selected\""; ?>
				value="fr">francais</option>
			<option
			<?php if (@LANGUAGE_CODE == 'eng') echo "selected=\"selected\""; ?>
				value="eng">english</option>
			<option
			<?php if (@LANGUAGE_CODE == 'spa') echo "selected=\"selected\""; ?>
				value="spa">espanol</option>
			<option
			<?php if (@LANGUAGE_CODE == 'pt') echo "selected=\"selected\""; ?>
				value="pt">portugues</option>
		</select></td>
		<td></td>
	</tr>
	<tr class="row1">
		<td><strong><?php echo PAYLINE_TEXT_TEMPLATE_URL?></strong></td>
		<td><input type="text" name="PAYLINE_TEMPLATE_URL" class="inputbox"
			size="50" value="<?php echo CUSTOM_PAYMENT_TEMPLATE_URL ?>" /></td>
		<td></td>
	</tr>
	<tr class="row0">
		<td><strong><?php echo PAYLINE_TEXT_PAGE_CODE?></strong></td>
		<td><input type="text" name="PAYLINE_PAGE_CODE" class="inputbox"
			size="50" value="<?php echo CUSTOM_PAYMENT_PAGE_CODE ?>" /></td>
		<td></td>
	</tr>
</table>
			<?php
	}

	function has_configuration() {
		// return false if there's no configuration
		return true;
	}

	/**
	 * Returns the "is_writeable" status of the configuration file
	 * @param void
	 * @returns boolean True when the configuration file is writeable, false when not
	 */
	function configfile_writeable() {
		return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}

	/**
	 * Returns the "is_readable" status of the configuration file
	 * @param void
	 * @returns boolean True when the configuration file is writeable, false when not
	 */
	function configfile_readable() {
		return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}

	/**
	 * Writes the configuration file for this payment method
	 * @param array An array of objects
	 * @returns boolean True when writing was successful
	 */
	function write_configuration( &$d ) {
		global $vmLogger, $mosConfig_live_site;;
		$lang = jfactory::getLanguage();
		$name= $lang->getBackwardLang();
		if( file_exists(CLASSPATH ."payment/payline/languages/lang.".$name.".admin.php")) {
			include(CLASSPATH ."payment/payline/languages/lang.".$name.".admin.php");
		} else {
			include(CLASSPATH ."payment/payline/languages/lang.french.admin.php");
		}
			
		$my_config_array = array(
                "MERCHANT_ID" => vmget($d,'PAYLINE_MERCHANT_ID'),
                "ACCESS_KEY" => vmget($d,'PAYLINE_ACCESS_KEY'),
                "PROXY_HOST" => vmget($d,'PAYLINE_PROXY_HOST'),
                "PROXY_PORT" => vmget($d,'PAYLINE_PROXY_PORT' ),
				"PROXY_LOGIN" => vmget($d, 'PAYLINE_PROXY_LOGIN'),
				"PROXY_PASSWORD" => vmget($d, 'PAYLINE_PROXY_PASSWORD'),
                "PAYMENT_ACTION" => vmget($d, 'PAYLINE_PAYMENT_TYPE', '100'),
                "PAYMENT_MODE" => vmget($d, 'PAYLINE_PAYMENT_MODE', 'CPT'),
                "CONTRACT_NUMBER" => vmget($d, 'PAYLINE_CONTRACT', '001'),
                "CONTRACT_NUMBER_LIST" => vmget($d, 'PAYLINE_CONTRACT_LIST', '001'),
                "RETURN_URL" => $mosConfig_live_site.'/administrator/components/com_virtuemart/payline_notify.php',
                "CANCEL_URL" => $mosConfig_live_site.'/administrator/components/com_virtuemart/payline_notify.php',
                "NOTIFICATION_URL" => $mosConfig_live_site.'/administrator/components/com_virtuemart/payline_notify.php',
				"ORDER_LIST_URL" => $mosConfig_live_site.'/index.php?page=account.index&option=com_virtuemart',
      			"SECURITY_MODE" => vmget($d, 'PAYLINE_SECURITY_MODE', 'SSL'),
                "LANGUAGE_CODE" => vmget($d, 'PAYLINE_LANGUAGE_CODE', 'eng'),
      			"CUSTOM_PAYMENT_TEMPLATE_URL" => vmget($d, 'PAYLINE_TEMPLATE_URL'),
				"CUSTOM_PAYMENT_PAGE_CODE" => vmget($d, 'PAYLINE_PAGE_CODE')
		);

		$config = "<?php\n";
		$config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
		foreach( $my_config_array as $key => $value ) {
			if(($key == 'PROXY_HOST' || $key == 'PROXY_PORT') && trim($value) == '')
			$config .= "define ('$key', null);\n";
			else
			$config .= "define ('$key', '$value');\n";
		}
		if(vmget($d, 'PAYLINE_ENVIRONMENT') == 'PROD'){
			$config .= "define ('PRODUCTION', TRUE);\n";
		}else{
			$config .= "define ('PRODUCTION', FALSE);\n";
		}

		$config .= "?>";

		if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
			fputs($fp, $config, strlen($config));
			fclose ($fp);
			return true;
		}
		else
		return false;
	}

	function process_payment($order_number, $order_total, &$d) {
		global $vendor_currency;
			
		$amount = $order_total * 100;

		$webPayment = $this->makeRequest($order_number, $amount, $vendor_currency);

		if(isset($webPayment)){
			if($webPayment['result']['code'] == '00000'){
				header("location:".$webPayment['redirectURL']);
				return true;
			}else{
				echo "PAYLINE ERROR  (code ".$webPayment['result']['code'].") : ".$webPayment['result']['longMessage']."<br/>";
				// echo "<a href='".ORDER_LIST_URL."'>".PAYLINE_TEXT_ORDER_LIST_URL."</a>";
			}
		}
	}

	function makeRequest($order_number, $amount, $currency) {
		global $mosConfig_absolute_path;
		
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
		require_once($mosConfig_absolute_path."/payline_1.1.8/lib/paylineSDK.php");

		define ('PAYMENT_CURRENCY', $this->currencies[$currency]);
		define ('ORDER_CURRENCY', PAYMENT_CURRENCY);

		$webPayment = array();
		$payline = new paylineSDK();

		//RETURN,
		$payline -> returnURL = RETURN_URL;
		//CANCEL,
		$payline -> cancelURL = CANCEL_URL;
		//NOTIFICATION',
		$payline -> notificationURL = NOTIFICATION_URL;

		// PAYMENT
		$webPayment['payment']['amount'] = $amount;
		$webPayment['payment']['currency'] = PAYMENT_CURRENCY;

		// ORDER
		$webPayment['order']['ref'] = $order_number;
		$webPayment['order']['amount'] = $webPayment['payment']['amount'];
		$webPayment['order']['currency'] =  ORDER_CURRENCY;
		
		// BUYER
		$webPayment['buyer']['lastName'] = $_SESSION['auth']['last_name'];
		$webPayment['buyer']['firstName'] = $_SESSION['auth']['first_name'];
		$webPayment['buyer']['email'] = $_SESSION['__default']['user']->email;

		// TODO complter ADDRESS
		$webPayment['address']['name'] = $webPayment['buyer']['firstName'].' '.$webPayment['buyer']['lastName'];
		$webPayment['address']['street1'] = '';
		$webPayment['address']['street2'] = '';
		$webPayment['address']['cityName'] = '';
		$webPayment['address']['zipCode'] = $_SESSION['auth']['zip'];
		$webPayment['address']['country'] = $_SESSION['auth']['country'];
		$forbidenCars = array(' ','.','(',')','-');
		$webPayment['address']['phone'] = str_replace($forbidenCars,'','');

		// PRIVATE DATA
		$privateData = array();
		$privateData['key'] = "order_number";
		$privateData['value'] = $webPayment['order']['ref'];
		$payline->setPrivate($privateData);

		// EXECUTE
		$result = $payline->do_webpayment($webPayment);
		
		return $result;
	}
}
